declare module 'typedi/Container' {
	export interface Instance {
	    type: Function;
	    instance: Object;
	}
	export interface CustomParamHandler {
	    type: Function;
	    index: number;
	    getValue: () => any;
	}
	export class Container {
	    private static instances;
	    private static customParamHandlers;
	    private static defaultParameters;
	    static registerCustomParamHandler(paramHandler: CustomParamHandler): void;
	    static registerDefaultInitializationParameter(type: Function, params?: any[]): void;
	    static get<T>(type: Function, params?: any[]): T;
	    static set(type: Function, value: any): void;
	    private static findInstanceOfType(type);
	    private static findCustomParamHandler(type, index);
	    private static mapParams(type, params);
	    private static isParamValid(param);
	}

}
declare module 'typedi/Inject' {
	export function Inject(type?: Function): (target: any, key: string) => void;

}
declare module 'typedi/Require' {
	export function Require(name: string): (target: Function, key: string, index: number) => void;

}
declare module 'typedi/Resolve' {
	export function Resolve(): (target: Function) => void;

}
declare module 'typedi/Service' {
	export function Service(): (target: Function) => void;

}
